= nng_push_open(3)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_push_open - create push socket

== SYNOPSIS

[source,c]
----
#include <nng/nng.h>
#include <nng/protocol/pipeline0/push.h>

int nng_push0_open(nng_socket *s);

int nng_push0_open_raw(nng_socket *s);
----

== DESCRIPTION

The `nng_push0_open()` function creates a xref:nng_push.7.adoc[_push_] version 0
xref:nng_socket.5.adoc[socket] and returns it at the location pointed to by _s_.

The `nng_push0_open_raw()` function creates a xref:nng_push.7.adoc[_push_] version 0
xref:nng_socket.5.adoc[socket] in
xref:nng.7.adoc#raw_mode[raw] mode and returns it at the location pointed to by _s_.

== RETURN VALUES

These functions return 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient memory is available.
`NNG_ENOTSUP`:: The protocol is not supported.

== SEE ALSO

[.text-left]
xref:nng_socket.5.adoc[nng_socket(5)],
xref:nng_pull.7.adoc[nng_pull(7)],
xref:nng_push.7.adoc[nng_push(7)],
xref:nng.7.adoc[nng(7)]
